<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="计划名称：" prop="name">
        <el-input
          v-model.trim="queryParams.name"
          placeholder="请输入计划名称"
          clearable
          size="small"
          style="width: 140px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:admin:add']"
        >新增</el-button>
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['system:admin:export']"
        >导出</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="adminList" height="calc(100vh - 28vh)">
      <el-table-column label="计划名称" align="center" prop="planName"  show-overflow-tooltip />
      <!-- <el-table-column label="周期" align="center" prop="cycle"  show-overflow-tooltip /> -->
      <el-table-column label="周期" align="center" prop="cycle"  show-overflow-tooltip >
        <template slot-scope="scope">
          <span>{{scope.row.cycle == 1 ? "日" : scope.row.cycle == 2 ? "周" : "月"}}</span>
        </template>
      </el-table-column>
      <el-table-column label="计划开始时间" align="center" prop="startDate"  show-overflow-tooltip />
      <el-table-column label="计划开始时间" align="center" prop="endDate"  show-overflow-tooltip />
      <el-table-column label="执行开始时间" align="center" prop="startInspectTime"  show-overflow-tooltip />
      <el-table-column label="执行结束时间" align="center" prop="endInspectTime"  show-overflow-tooltip />
      <el-table-column label="执行班组" align="center" prop="teamName"  show-overflow-tooltip />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:admin:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:admin:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 修改、新增对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body :before-close="cancel" :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="auto" >
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="计划名称" prop="planName">
              <el-input v-model="form.planName" placeholder="请填写计划名称" @input="onInput()" maxlength="15" show-word-limit />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="执行班组" prop="teamId">
              <el-select
                v-model="form.teamId"
                placeholder="请选择执行班组"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in teamList"
                  :key="dict.id"
                  :label="dict.teamName"
                  :value="dict.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="单位名称" prop="companyCode">
                  <el-select
                    v-model="form.companyCode"
                    placeholder="请选择单位名称"
                    size="small"
                    style="width: 160px"
                  >
                    <el-option
                      v-for="dict in companyList"
                      :key="dict.dictValue"
                      :label="dict.dictLabel"
                      :value="dict.dictValue"
                    />
                  </el-select>
                </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="周期" prop="cycle">
              <el-select
                v-model="form.cycle"
                placeholder="请选择周期"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in cycleList"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="计划开始时间" prop="startDate">
              <el-date-picker
                v-model="form.startDate"
                type="date"
                style="width:160px"
                placeholder="选择日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="计划结束时间" prop="endDate">
              <el-date-picker
                v-model="form.endDate"
                type="date"
                style="width:160px"
                placeholder="选择日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="执行开始时间" prop="startInspectTime">
              <el-select
                v-model="form.startInspectTime"
                placeholder="请选择开始时间"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in inspectTimeList"
                  :key="dict.dictValue"
                  :label="dict.dictValue"
                  :value="dict.dictValue"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="执行结束时间" prop="endInspectTime">
              <el-select
                v-model="form.endInspectTime"
                placeholder="请选择结束时间"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in inspectTimeList"
                  :key="dict.dictValue"
                  :label="dict.dictValue"
                  :value="dict.dictValue"
                />
              </el-select>
            </el-form-item>
          </el-col>
          
          <el-col style="font-size:16px;font-weight:700;margin:10px 0 20px;">巡更路线</el-col>
          <el-table v-loading="loading2" :data="adminList2" height="200"   @select="dialogCheck" ref="dataTable">
            <el-table-column type="selection" />
            <el-table-column label="线路名称" align="center" prop="name"  show-overflow-tooltip />
            <el-table-column label="创建时间" align="center" prop="createTime"  show-overflow-tooltip />
          </el-table>
          <pagination
            v-show="total2>0"
            :total="total2"
            :page.sync="queryParams2.current"
            :limit.sync="queryParams2.size"
            @pagination="getList2"
          />
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />
    <a href="" download="" id="xz" style="position: absolute;z-index: -1;opacity: 0;"></a>
  </div>
</template>
<script>
import { BASEPATH } from "@/assets/js/common.js";
import { listChannel } from "@/api/system/product";
import { timestampToTime, getTimeFormat,YearMonthDate } from "@/assets/js/dataFormate.js";
import { getPlanPath } from "@/api/business/OM/MochaITOM/route";
import { addMaintianPlan, delMaintianPlan, updateMaintianPlan, getMaintianPlan, exportMaintianPlan } from "@/api/business/OM/MochaITOM/plan";
import { getDevopsTeam } from "@/api/business/OM/MochaITOM/crew";
export default {
  name: "Floor",
  data() {
    return {
      loading:true,
      loading2:true,
      exportLoading:false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 总条数
      total2: 0,
      // 参数表格数据
      adminList: [],
      adminList2:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        current: 1,
        size: 20,
        name: undefined,
      },
      // 查询参数
      queryParams2: {
        current: 1,
        size: 20,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        planName: [
          { required: true, message: "任务名称不能为空",  trigger: "blur"  }
        ],
        teamId: [
          { required: true, message: "班组名称不能为空",  trigger: ["blur",'change']  }
        ],
        companyCode: [
          { required: true, message: "单位名称不能为空",  trigger: ["blur",'change']}
        ],
        cycle: [
          { required: true, message: "周期不能为空",  trigger: ["blur",'change']}
        ],
        startDate: [
          { required: true, message: "计划开始时间不能为空",  trigger: ["blur",'change']}
        ],
        endDate: [
          { required: true, message: "计划结束时间不能为空",  trigger: ["blur",'change']}
        ],
        startInspectTime: [
          { required: true, message: "执行开始时间称不能为空",  trigger: ["blur",'change']}
        ],
        endInspectTime: [
          { required: true, message: "执行结束时间称不能为空",  trigger: ["blur",'change']}
        ],
      },
      // 公司列表
      companyList: [],
      zrr:[],
      cycleList:[
        {dictValue:1,dictLabel:"日"},
        {dictValue:2,dictLabel:"周"},
        {dictValue:3,dictLabel:"月"},
      ],
      inspectTimeList:[],

      dateRange:[],
      teamList:[],
      selectioned:'',//单选中的值
    };
  },
  created() {
    this.getList();//初始化table
    this.zxtime()//执行时间
  },
  methods: {
    
   
    //强制el-input刷新
    onInput(){
        this.$forceUpdate();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.queryParams = {
        name:undefined,
        current:1,
        size:20
      }
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 表单重置
    reset() {
      this.form = {};
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 执行时间 */
    zxtime(){
      let arr = []
      for(let i = 0; i<48;i++){
        arr[i] = {}
        if(i%2 == "NaN"){
          arr[i].dictValue="00:00:00"
        }
        if(i%2 == "0"){
          if(i/2>=10){
            arr[i].dictValue= i/2 + ":00:00"
          }else{
            arr[i].dictValue="0" + i/2 + ":00:00"
          }
        }
        if(i%2 == "1"){
          if(i/2>=10){
            arr[i].dictValue=(i-1)/2 + ":30:00"
          }else{
            arr[i].dictValue="0" + (i-1)/2 + ":30:00"
          }
        }
      }
      this.inspectTimeList = arr
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true;
      getMaintianPlan(this.queryParams).then(response => {
        this.adminList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
      /* 公司列表 */
      listChannel(this.queryParams).then(response => {
        if(response.data.records.length>0){
          this.companyList = response.data.records.map(val =>{
            return {
              dictValue:val.ownerId,
              dictLabel:val.ownerName,
              address:val.ownerAddress,
            }
          })
        }
      });
      getDevopsTeam(this.queryParams).then(response => {
        if(response.data.records.length>0){
          this.teamList = response.data.records;
        }
      })
    },
    getList2(row){
        this.adminList2 = []
        getPlanPath(this.queryParams2).then(response => {
            this.adminList2 = response.data.records;
            if(row){
                let list = []
                for(let i = 0; i<this.adminList2.length;i++){
                    if(row.planPathId == this.adminList2[i].id){
                        list.push(this.adminList2[i])
                    }
                }
                setTimeout(() => {
                    var that = this;
                    that.$nextTick(() => {
                        if(list){
                            list.forEach((row) => {
                                that.$refs.dataTable.toggleRowSelection(row, true)
                            })
                        }
                    })
                    this.total2 = response.data.total;
                    this.loading2 = false;
                })
            }else{
                this.total2 = response.data.total;
                this.loading2 = false;
            }
        });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.title = "修改";
      this.form = JSON.parse(JSON.stringify(row))
      this.getList2(row)
      this.open = true;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getList2()
      this.open = true;
      this.title = "新增";
      this.list = []
    },
    /** 提交按钮 */
    submitForm(row) {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.endDate = timestampToTime(this.form.endDate)
          this.form.startDate = timestampToTime(this.form.startDate)
          let start = YearMonthDate().split(" ")[0] + " " + this.form.startInspectTime
          let end = YearMonthDate().split(" ")[0] + " " + this.form.endInspectTime
          if(getTimeFormat(this.form.endDate) < getTimeFormat(this.form.startDate)){
            this.msgError("计划结束时间不能小于计划开始时间");
            return
          }
          if(getTimeFormat(end) < getTimeFormat(start)){
            this.msgError("执行结束时间不能小于执行开始时间");
            return
          }
          this.loading = true
          if (this.form.id != undefined) {
            updateMaintianPlan(this.form).then(response => {
              this.loading = false,
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).catch(()=>{
              this.loading = false
            })
          } else {
            addMaintianPlan(this.form).then(response => {
              this.loading = false
              if(response.status == "SUCCESS"){
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            }).catch((err)=>{
              this.loading = false
            })
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delMaintianPlan(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** table */
    dialogCheck(selection, row){
      this.$refs.dataTable.clearSelection()
        if (selection.length === 0) { // 判断selection是否有值存在
            return
        }
        if (row) {
            this.selectioned = row
            this.$refs.dataTable.toggleRowSelection(row, true)
            this.form.planPathId = row.id
            this.form.planPathName = row.name
        }
    },
    /** 导出按钮操作 */
    handleExport() {
      exportMaintianPlan(this.queryParams).then(response =>{
        this.exportLoading = false;
        document.getElementById("xz").href = BASEPATH() + response.data
        document.getElementById("xz").download = response.data
        document.getElementById("xz").click()
      })
    }
  }
};
</script>
